#!/bin/bash

#this script pushs GRB files to ssec ftp for AIT to pull

#current_time - day this script is run
#savdisk - output directory root e.g. /cimss/REALTIME_PROXY
#bday - GRB directory name YYY_MM_DD_00

current_time=$1
savdisk=$2

#current_time is day this script is run
year=`echo "${current_time}" | cut -c1-4`
month=`echo "${current_time}" | cut -c6-7`
day=`echo "${current_time}" | cut -c9-10`
hr=`echo "${current_time}" | cut -c12-13`

#make directory name of CRTM out

bday=${year}_${month}_${day}_${hr}

echo ' Tar files in GRB date directory '${bday}

cd ${savdisk}/$bday

tar -cvf GRB_scaled_band01.tar GRB_scaled_band01*
tar -cvf GRB_scaled_band02.tar GRB_scaled_band02*
tar -cvf GRB_scaled_band03.tar GRB_scaled_band03*
tar -cvf GRB_scaled_band04.tar GRB_scaled_band04*
tar -cvf GRB_scaled_band05.tar GRB_scaled_band05*
tar -cvf GRB_scaled_band06.tar GRB_scaled_band06*
tar -cvf GRB_scaled_band07.tar GRB_scaled_band07*
tar -cvf GRB_scaled_band08.tar GRB_scaled_band08*
tar -cvf GRB_scaled_band09.tar GRB_scaled_band09*
tar -cvf GRB_scaled_band10.tar GRB_scaled_band10*
tar -cvf GRB_scaled_band11.tar GRB_scaled_band11*
tar -cvf GRB_scaled_band12.tar GRB_scaled_band12*
tar -cvf GRB_scaled_band13.tar GRB_scaled_band13*
tar -cvf GRB_scaled_band14.tar GRB_scaled_band14*
tar -cvf GRB_scaled_band15.tar GRB_scaled_band15*
tar -cvf GRB_scaled_band16.tar GRB_scaled_band16*

#ftp grb data
HOST=ftp.ssec.wisc.edu
USER=anonymous
PASS=todds@ssec.wisc.edu
ftp -inv $HOST << EOF
user $USER $PASS
cd ABI/REALTIME_PROXY 
binary
prompt
put GRB_scaled_band01.tar
put GRB_scaled_band02.tar
put GRB_scaled_band03.tar
put GRB_scaled_band04.tar
put GRB_scaled_band05.tar
put GRB_scaled_band06.tar
put GRB_scaled_band07.tar
put GRB_scaled_band08.tar
put GRB_scaled_band09.tar
put GRB_scaled_band10.tar
put GRB_scaled_band11.tar
put GRB_scaled_band12.tar
put GRB_scaled_band13.tar
put GRB_scaled_band14.tar
put GRB_scaled_band15.tar
put GRB_scaled_band16.tar
bye
EOF

/bin/rm *.tar

exit
