;;;;;;;;;;******************************************************************************************
FUNCTION READ_CALNEX_NETCDF_01, inputfiles ,  xx=xx, yy=yy, rep=rep, vars=vars, latlon=latlon ;, outputfile=outfile, xx=xx, yy=yy, nvars=nvars, lineele=lineele, vars=vars, ii=ii
	if not keyword_set(dprint ) then dprint = 0
	if not keyword_set( outputfile ) then outputfile=''
		
;PRINT, inputfiles
;;	west_east=2654 & south_north=1222 
         zz=N_ELEMENTS(inputfiles)  
;;	IF (katr EQ 1) THEN BEGIN
;;		west_east=753 
;;		south_north=685
;;	ENDIF

;;vars= the variable index to read.
;;nvars=the number of variables to create.

dname1='x' & dname2='y'
; dname1=xx & dname2=yy 
 
if not keyword_set( xx ) then dname1='west_east' 
if not keyword_set( yy ) then dname2='south_north'

	IF (inputfiles(0) NE '')THEN BEGIN
		
		ncdfid= NCDF_OPEN(inputfiles(0))
   		fileinfo= NCDF_INQUIRE(ncdfid)
                 
    WE = NCDF_DIMID( ncdfid, dname1) 
		SE = NCDF_DIMID( ncdfid, dname2)
		
		NCDF_DIMINQ, ncdfid, WE, Name1, Size1 
		NCDF_DIMINQ, ncdfid, SE, Name2, Size2

		ngatts=fileinfo.ngatts
    nvars=fileinfo.nvars
		gattrnames=STRARR(ngatts)
		
		gatts={name:'',value:''}
		gats=REPLICATE(gatts,ngatts)


  ; rep=1  ; & size2=1
  
		
		varnames=STRARR(nvars)
		avarset={data:FLTARR(Size1, Size2),var:'', attr:STRARR(8), attrval:STRARR(8),nvars:nvars, nvarsatt:0, ngatts:ngatts}
		dataset=avarset  ;REPLICATE(avarset,rep) ;  nvars)
    
    
    newoutdata= {gats:gats,dataset:dataset}
	  ;newoutdata=outdata ;REPLICATE(outdata, zz) ;nvars)

		NCDF_CLOSE, ncdfid
	;;ENDIF
	
	FOR ww=0, zz-1 DO BEGIN
	
		ncdfid= NCDF_OPEN(inputfiles(0))
   	fileinfo= NCDF_INQUIRE(ncdfid)

		ngatts=fileinfo.ngatts
    ;nvars=fileinfo.nvars
		gattrnames=STRARR(ngatts)
		


		 FOR i=0L, ngatts -1L DO BEGIN
			gattrnames[i]= NCDF_ATTNAME(ncdfid,i, /global)
				       NCDF_ATTGET,ncdfid, gattrnames[i], gattvalue, /global
				       gats(i).name=gattrnames[i]
				       gats(i).value=string(gattvalue)
				       IF (dprint EQ 1) THEN printf, 1, gats(i)
					;print, 'gats' ,gats(i)
		 ENDFOR
		
		
		FOR j=0L, nvars -1L DO BEGIN
		       varinfo=NCDF_VARINQ(ncdfid,j)
           varnames(j)=varinfo.name  
		ENDFOR
		
		 
	;;;;;; Added for simplification   ;;;;;
	
	var_x={data:FLTARR(Size1),name:'', attr:STRARR(2,4)}	
	var_y={data:FLTARR(Size2),name:'', attr:STRARR(2,4)}  ; long_name:'', units:'', scale:'', offset:''}	
	proj_info={data:strarr(2,11)}  ;name, value
	;var_elements={data:FLTARR(Size1),units:'', name:''}  
  ;var_lines={data:FLTARR(Size2),units:'', name:''} 	
  var_lats={data:FLTARR(Size1,Size2),units:'', name:''}  
  var_lons={data:FLTARR(Size1,Size2),units:'', name:''}  
  
  
  
  avarset={data:FLTARR(Size1, Size2),var:'', attr:STRARR(8), attrval:STRARR(8),nvars:nvars, nvarsatt:0, ngatts:ngatts}
  dataset=avarset
  IF (rep GT 1) THEN dataset=REPLICATE(avarset,rep)
  
  newoutdata= {gats:gats,dataset:dataset, x:var_x, y:var_y, proj_info:proj_info, lats:var_lats, lons:var_lons}
		
		IF (rep LE 1) THEN vars=varnames(0)
		
		start=1    ; based on "varnames"
		IF (rep GT 1) THEN start=2
		
		
		 ;;;;X information ;;;    
    cc=where(varnames EQ 'x')  
    varinfo=NCDF_VARINQ(ncdfid,varnames[cc(0)])  ;start+2])
    varid=NCDF_VARID(ncdfid, varinfo.name)
     NCDF_VARGET,ncdfid, varid, temp_data
        var_x.data=temp_data
    FOR aa=0, varinfo.natts -1 DO BEGIN
        pp=NCDF_attname(ncdfid, varid, aa)
       NCDF_ATTGET, ncdfid, varid, pp, attvalue
        var_x.attr(0,aa)=string(PP); Attribute name
        var_x.attr(1,aa)=string(attvalue); Attribute value
    ENDFOR
    
   ;;;;Y information ;;;    
    cc=where(varnames EQ 'y')  
    varinfo=NCDF_VARINQ(ncdfid,varnames[cc(0)])  ;start+2])
    varid=NCDF_VARID(ncdfid, varinfo.name)
     NCDF_VARGET,ncdfid, varid, temp_data
        var_y.data=temp_data
    FOR aa=0, varinfo.natts -1 DO BEGIN
        pp=NCDF_attname(ncdfid, varid, aa)
       NCDF_ATTGET, ncdfid, varid, pp, attvalue
        var_y.attr(0,aa)=string(PP); Attribute name
        var_y.attr(1,aa)=string(attvalue); Attribute value
    ENDFOR
		
;    var_x.name=varinfo.name 
;    var_x.units='projection_x_coordinate'
;    NCDF_VARGET,ncdfid, varid, temp_data
;    var_x.data=temp_data
;    
;		varinfo=NCDF_VARINQ(ncdfid,varnames[start+1])
;		varid=NCDF_VARID(ncdfid, varinfo.name)
;    var_y.name=varinfo.name 
;    var_y.units='projection_y_coordinate'
;    NCDF_VARGET,ncdfid, varid, temp_data
;    var_y.data=temp_data
    
    
    ;;;;Projection information ;;;
    
    cc=where(varnames EQ 'Projection')  
    varinfo=NCDF_VARINQ(ncdfid,varnames[cc(0)])  ;start+2])
    varid=NCDF_VARID(ncdfid, varinfo.name)
    FOR aa=0, varinfo.natts -1 DO BEGIN
        pp=NCDF_attname(ncdfid, varid, aa)
        NCDF_ATTGET, ncdfid, varid, pp, attvalue
        proj_info.data(0,aa)=string(PP); Attribute name
        proj_info.data(1,aa)=string(attvalue); Attribute value
    ENDFOR

    
    ;varinfo=NCDF_VARINQ(ncdfid,varnames[start+3])
    ;varid=NCDF_VARID(ncdfid, varinfo.name)
    ;var_lines.name=varinfo.name 
    ;var_lines.units='none'
    ;NCDF_VARGET,ncdfid, varid, temp_data
    ;var_lines.data=temp_data
    
    
    IF (latlon GT 0) THEN BEGIN  
        varinfo=NCDF_VARINQ(ncdfid,varnames[0])
        varid=NCDF_VARID(ncdfid, varinfo.name)
        var_lats.name=varinfo.name 
        var_lats.units='degrees_north'
        NCDF_VARGET,ncdfid, varid, temp_data
        var_lats.data=temp_data
    
      varinfo=NCDF_VARINQ(ncdfid,varnames[1])
      varid=NCDF_VARID(ncdfid, varinfo.name)
      var_lons.name=varinfo.name 
      var_lons.units='degrees_east'
      NCDF_VARGET,ncdfid, varid, temp_data
      var_lons.data=temp_data
    ENDIF ELSE BEGIN
        var_lats.name='Latitude' 
        var_lats.units='degrees_north'
        var_lats.data=0
   
       var_lons.name='Longitude' 
       var_lons.units='degrees_east'
       var_lons.data=0
    ENDELSE
		
;print,varnames		
		nvars=rep
		FOR i=0, rep -1  DO BEGIN
		    j=WHERE(varnames(*) EQ vars(i))
;print,i,vars(i)		   
          varinfo=NCDF_VARINQ(ncdfid,j(0))
          dataset(i).var=varinfo.name  
;           print, dataset(i).var
             varid=NCDF_VARID(ncdfid, varinfo.name)
             NCDF_VARGET,ncdfid, varid, temp_data
             dataset(i).data = temp_data
             kkk= where (temp_data GE -997) & lll=SIZE(KKK)
          IF (dprint EQ 1) THEN printf,1 ,dataset(i).data
          natts=varinfo.natts
          dataset.nvarsatt=natts
        FOR k=0L, natts- 1L DO BEGIN
          dataset(i).attr(k)=NCDF_ATTNAME(ncdfid,varid, k) 
          NCDF_ATTGET, ncdfid, varid, dataset(i).attr(k), attvalue
          IF ((i LE 1) AND  (k EQ 2) AND nvars  GE 3) THEN BEGIN
              dataset(i).attrval(k)= string(attvalue(0))
           ENDIF ELSE BEGIN
           dataset(i).attrval(k)= string(attvalue) 
          ENDELSE
        ENDFOR  
        IF (i EQ 0) THEN BEGIN
            newoutdata.gats=gats 
            newoutdata.x= var_x
            newoutdata.y= var_y
            newoutdata.proj_info= proj_info
           ; newoutdata.elements= var_elements   
            newoutdata.lats= var_lats
            newoutdata.lons= var_lons         
        ENDIF     
        newoutdata.dataset(i)= dataset(i)
    ENDFOR 
  		
		NCDF_CLOSE, ncdfid
		CLOSE, /ALL
	ENDFOR
	
 ENDIF ELSE BEGIN
    newoutdata=''
 ENDELSE
 
RETURN, newoutdata

END
;;;;***********************************************************************************************









