
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FUNCTION TBBtoBrit_val, brit_temp     ;CONVERT A BRIGHTNESS TEMPERATURE TO BRIT. VALUE
  brit_val=brit_temp
  brit_val(*,*)=0.0 
 con1=418   &  con2=660   &  tlim=242.0  & range=[163, 330]
 lower_temps= WHERE(brit_temp LT tlim AND brit_temp NE -999.0)    & upper_temps= WHERE(brit_temp GE tlim)
 too_low=WHERE(brit_temp LT range[0])  & too_high= WHERE(brit_temp GT range[1])
 
 IF (N_ELEMENTS(lower_temps) GT 1) THEN  brit_val(lower_temps) = (con1 -ROUND(brit_temp(lower_temps)))
 IF (N_ELEMENTS(upper_temps) GT 1) THEN  brit_val(upper_temps) = (con2 -ROUND(2 * brit_temp(upper_temps)))
  
 IF (N_ELEMENTS(too_low) GT 1) THEN  brit_val(too_low)=0  ;255  
 IF (N_ELEMENTS(too_high) GT 1) THEN  brit_val(too_high)=0
  badd=WHERE(brit_temp LT 0)
  IF (SIZE(badd, /DIMENSION) GT 0) THEN brit_val(badd)=0.0
  
 RETURN, brit_val
END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;SUB ROUTINES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;CONVERT RADIACNES TO BRIGHTNESS TEMPERATURES   ;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;CONVERT BRIGHTNESS TEMPERATURES TO BRIT VALUES     ;;;;;;;;;;

FUNCTION RadtoBrit_temp, radiance,ii       ;Convert radiance to Brightness temp.
     
     ;;;; method 3 IN ATBD
    ;; C1 = 1.191066e-05    &    C2 = 1.438833
    ;; WaveNum= [2564.1501, 1617.1500, 1439.1500, 1362.1000, 1176.1500, 1041.1500,  966.1000,  893.1500,  813.1500,  752.1500]
    ;;  BC1= [0.51139, 2.11916, 0.33222, 0.07096, 0.17913, 0.10525, 0.13202, 0.24744, 0.26205, 0.07139]
    ;;  BC2= [0.99928, 0.99543, 0.99921, 0.99982, 0.99949, 0.99967, 0.99956, 0.99912, 0.99898, 0.99970]
    ;;  ss=ii-7
    ;; www=WHERE(radiance LT 0) ;-999.0)
      
    ;; FK1=C1*(WaveNum(*)^3)     &   FK2=C2*WaveNum
    ;; Var_Tmpy0=ALOG((FK1(ss)/radiance(*,*))+1)
    ;; Var_Tmpy=FK2(ss)/Var_tmpy0(*,*)
    ;; TBB=(Var_Tmpy - BC1(ss))/BC2(ss) 
    ;; badd=WHERE(~FINITE(TBB))
    ; ;IF N_ELEMENTS(badd GT 1) THEN 
    ; TBB(badd(*,*))=-999.0
     
     ;;;;;METHOD 2 IN ATBD
     BC1= [0.50777, 2.12504, 0.33291, 0.06984, 0.17462, 0.10861, 0.13445, 0.25361, 0.27049, 0.07574]
     BC2= [0.99929, 0.99541, 0.9992, 0.99983, 0.99951, 0.99966, 0.99955, 0.9991, 0.99894, 0.99968]
     FK1= [2.00774E+05, 5.03614E+04, 3.54940E+04, 3.00925E+04, 1.93733E+04, 1.34382E+04, 1.07364E+04, 8.48310E+03, 6.40146E+03, 5.06603E+03]
     FK2= [3.68909E+03, 2.326570E+03, 2.07047E+03, 1.95961E+03, 1.69207E+03, 1.49784E+03, 1.38986E+03, 1.28490E+03, 1.16980E+03, 1.08203E+03 ]
     
      ss=ii-7
      
 ;     t_bc1=STRING(STRTRIM(BC1(ss),1)) & t_bc2=STRING(STRTRIM(BC2(ss),1))
 ;     t_fk1=STRING(STRTRIM(FK1(ss),1)) & t_fk2=STRING(STRTRIM(FK2(ss),1)) 



      www=WHERE(radiance LT 0) ;-999.0)
       
      TBB = [FK2(ss)/ALOG((FK1(ss)/radiance(*,*)+1)) - BC1(ss)]/BC2(ss)
      badd=WHERE(~FINITE(TBB))
      IF N_ELEMENTS(badd) GT 1 THEN BEGIN
       TBB(badd)=-999.0
      ; PRINT, 'STOP'
      ENDIF 
      
 RETURN,TBB
END



;

;;;;***********************************************************************************************
PRO WRITE_CMIP_VIS_FROM_GRB_SCALED_NETCDF,infile, outpre,multivar,katr, latlonfile, data2, ii=ii, mic_rad=mic_rad
  infile=infile  ;+ '.nc'
  xx='x' & yy='y' & var=1 & vars=0
    data=READ_ABI_NETCDF_01(infile,vars=vars, xx=xx, yy=yy, lineele=0)  
     lldata=data2.latlon
   	
   	ncoutfile=outpre ;+'.nc'
  	
	  spos=STRPOS(outpre,'abi_',  /REVERSE_SEARCH)
    ayear=STRMID(outpre, spos+4, 4 )    &    amonth=STRMID(outpre, spos+9, 2)
	  aday=STRMID(outpre, spos+11, 2 )    &    hrs=STRMID(outpre, spos+14, 2)
	  mins=STRMID(outpre, spos+16, 2 )          ;;;&    ayear=STRMID(outpre, spos+4, 4 )
	  
	  uu=size(data.dataset.data,/DIMENSIONS)    ;size(sdata.data, /DIMENSIONS)
	  xx=LONG(uu(0)) & yy=LONG(uu(1))           ;;2654,1222 i.e x and y dimensions. 


	  lons=lldata.xx.xx       ;xy.dataset(0).data                            ;lines    ;Latitudes
    lats=lldata.yy.yy       ;xy.dataset(1).data                            ;elements ;Longitude
	  newdata0=data.dataset(0).data                   ;scaled adiance.
    offset0=data.dataset(0).attrval(2)  &    scale0=data.dataset(0).attrval(3)
	
	  bnumber=['0.47','0.64', '0.865', '1.378', '1.61', '2.25', '3.90', '6.19','6.95', '7.34', '8.50', '9.61', '10.35', '11.2', '12.3', '13.3']
    E_sun=[1993.660, 1605.9593, 969.7815, 357.3011, 244.7938, 75.3057]  ;(w/(m2.um))
    min_rad=[-25.93664701,-20.28991094,-12.03764377,-4.52236858,-3.05961376,-0.96095066,-0.0114,-0.1692,-0.2472,-0.2871,-0.3909,-0.4617,-0.4935,-0.5154,-0.5262, -1.5726]  ;;W/(m2.str.um)
    max_rad=[804.03605737,628.98723908,373.16695681,140.19342584,94.84802665,29.78947040,24.962,28.366,44.998,79.831,134.93,108.44,183.62,198.71,212.28,170.19]  ;;W/(m2.str.um)
    pi=3.14159265
	  bit_depth=12
 
 IF (ii LE 6) THEN BEGIN
      bb= STRING('0'+STRTRIM(ii,1))
      dname1='ABI_Scaled_b'+bb     ;'ABI_scaledint_'+bb 
      lname1='ABI reflectance factor band'+ bb+ '('+ bnumber(ii-1) + 'um)'   ;sdata.dattrv(1)+ 
      units1='none'    ;'milliwatts/m2/steradian/cm-1'     ;sdata.dattr2v(0)
      ;cwlength1=sdata.dattrv(3)
      ;;vrange='0.0, 1.0'
   ENDIF 
   IF ( (ii GT 6) ) THEN BEGIN  ;(multivar EQ 1) AND
      bb= STRING('0'+STRTRIM(ii,1))
      IF (ii GT 9) THEN bb= STRING(STRTRIM(ii,1))
          dname1='ABI_Scaled_units0="milliwatts/m2/steradian/cm"   ;;;sdata.dattrv(2)TBB_b'+bb   ;'ABI_scaledint_'+bb 
          lname1='ABI brightness temperature band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
          units1='Kelvin'   ;sdata.dattrv2(0)
         ; cwlength1=sdata.dattrv2(3)
          ;;vrange1='0.0, 400.0'
  ENDIF


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;added to output Brit values for the validation files.
  ww='band0'
  IF (ii GT 9) THEN ww='band '
  aband=STRING(ww)+ (STRTRIM(ii,1))
 
    bb= STRING('0'+STRTRIM(ii,1))              
    IF (ii GT 9) THEN bb= STRING(STRTRIM(ii,1))
 
 
 IF ii LE 6 THEN BEGIN
     refl_data=newdata0
     
    ;;compute min, max of reflectance factors from min max of rad using (R.F=RAD*PI)/E_SUN for visible bands 
 
        min_refl=((min_rad(ii-1)*pi)/E_sun(ii-1))   ;;(R.F=RAD*PI)/E_SUN 
        max_refl=((max_rad(ii-1)*pi)/E_sun(ii-1))
 
    ;;;;; Compute the slopes and offsets for each visible band

        ;;;;slope=[y2-y1]/[x2-x1]
          scales=((max_refl-min_refl)/4095)  ; slopes\\
          offsets=min_refl  ;slopes(jj)*min_refl(jj) ;;offsets
   
            IF ii EQ 1 THEN BEGIN
                  print, 'slopes:', scales 
                  print, 'offsets:', offsets
            ENDIF
  
        
ENDIF ELSE BEGIN
   
       ff=size(newdata0)
       radiance=DBLARR(FF[1],FF[2])
       radiance(*,*)=(newdata0*scale0 +offset0)  ;& lats=lats0 & lons=lons0    ;& newdata2=sdata.data2
       
        brit_temp=RadtoBrit_temp(radiance,ii)                 ;;; Convert radiance to Brightness Temp;; From Walter's team
        newdata2=brit_temp
     
  
ENDELSE 
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


Time=float(0.001)

    cdfid=ncdf_create(ncoutfile, /clobber)

    ;;Dimensions	 
	        
	;ydimid =ncdf_dimdef(cdfid, 'y',  yy) ;'west_east' 
 ; xdimid =ncdf_dimdef(cdfid, 'x', xx)  ;'south_north'
 ; tdimid =ncdf_dimdef(cdfid, 'time', 1)
 ;; bdimid =ncdf_dimdef(cdfid, 'e_sun', 1)
  ;sdimid =ncdf_dimdef(cdfid, 'sw1', 22) ;number of swaths in FD
    ;;Variables 
  ; dname0='lines' & dname1='elements' & dname4='time' ;& dname5='brit_val'
  ; lname0='projection_y_coordinate' & lname1='projection_x_coordinate' & lname4='Image start time'
  ; units0='degrees_north' & units1='degrees_east' & units4=STRING('seconds since '+ ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins)    ;2005-05-07 0:0:0'
     
     
   
  ;;Dimensions           
  ydimid =ncdf_dimdef(cdfid, 'y',  yy) ;'' 
  xdimid =ncdf_dimdef(cdfid, 'x', xx)  ;''
  ;ldimid =ncdf_dimdef(cdfid, 'line',  yy) ;'' 
  ;edimid =ncdf_dimdef(cdfid, 'element', xx)  ;''
  tdimid =ncdf_dimdef(cdfid, 'time', 1)
  bdimid =ncdf_dimdef(cdfid, 'e_sun', 1)
  sdimid =ncdf_dimdef(cdfid, 'swath_t', 2) ;number of swaths in FD
  
	   
	   ;;Variables 
	 ;  dname3='Brit_val_12bit_b' +bb  &  lname3='Brightness values 12bit band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
   dname5='x' & dname6='elements' & dname7='y' & dname8='lines' & dname9='time' & dname12='E_sun'   ;& dname2='brit_val'
   lname5='projection_x_coordinate' & lname6='elements_x_dir' & lname7='projection_y_coordinate' & lname8='lines_y_dir' & lname9='Image start time'
   units5='None' & units6='None' & units7='None' & units8='None' & units9=STRING('seconds since '+ ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins)    ;2005-05-07 0:0:0'  
   
   output_time= STRING(ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins)  
	

 IF ( ii LE 6) THEN BEGIN
    ;;;convert to sting
    s_scale= STRTRIM(STRING(scales),1)  &  s_offset= STRTRIM(STRING(offsets),1)
    ;;get string length  
    l_scale= STRLEN(s_scale)      &    l_offset= STRLEN(s_offset)
    ;; find position of '.' in sting'
    p_scale_pos=STRPOS(s_scale, '.', /REVERSE_SEARCH)   &   p_offset_pos=STRPOS(s_offset, '.', /REVERSE_SEARCH)
    ;;define "format" 
    f_scale='(f'+ STRTRIM(STRING(l_scale),1)+'.'+STRTRIM(STRING(l_scale -p_scale_pos -1),1)+')'
    f_offset='(f'+ STRTRIM(STRING(l_offset),1)+'.'+STRTRIM(STRING(l_offset -p_offset_pos -1),1)+')'
    
 ENDIF ELSE BEGIN
     s_scale= STRTRIM(STRING(scale0,1))  &  s_offset= STRTRIM(STRING(offset0,1))
    ;;get string length  
    l_scale= STRLEN(s_scale)      &    l_offset= STRLEN(s_offset)
    ;; find position of '.' in sting'
    p_scale_pos=STRPOS(s_scale, '.', /REVERSE_SEARCH)   &   p_offset_pos=STRPOS(s_offset, '.', /REVERSE_SEARCH)
    ;;define "format" 
    f_scale='(f'+ STRTRIM(STRING(l_scale),1)+'.'+STRTRIM(STRING(l_scale -p_scale_pos -1),1)+')'
    f_offset='(f'+ STRTRIM(STRING(l_offset),1)+'.'+STRTRIM(STRING(l_offset -p_offset_pos -1),1)+')'
    
    offsets=offset0  
    scales=scale0
 ENDELSE 
  
 
 
  varid1= ncdf_vardef(cdfid, dname1, [xdimid, ydimid], /short) 
  ncdf_attput, cdfid, varid1, 'long_name' , lname1   
  ncdf_attput, cdfid, varid1, 'units' , units1 
  ncdf_attput, cdfid, varid1, 'add_offset' , STRING(offsets ,format=f_offset), /DOUBLE ;     '(f11.8)'
  ncdf_attput, cdfid, varid1, 'scale_factor' , STRING(scales ,format=f_scale), /DOUBLE  ;   '(f13.10)'
  ;ncdf_attput, cdfid, varid1, 'valid_min' ,  1     ;-0.10 ;'-0.10, 90000'
  ncdf_attput, cdfid, varid1, 'valid_range' , [1,65536] ;[1, 65536]    ;[1, 255]
  ncdf_attput, cdfid, varid1, '_FillValue' ,  0 ;-999     ;-0.123173  ;;; -999.0   ;;;
 ; ncdf_attput, cdfid, varid1, '_FillValue', -999.0       ;sdata.m2   ; -0.123173    ;;;-999.0  ;;miss1
  ncdf_attput, cdfid, varid1, 'grid_mapping', 'Projection' ;
  ncdf_attput, cdfid, varid1, 'coordinates' , 'y x' ; 'lines elements'

        
;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	;;;Added to outupt Brit values.
;	varid2= ncdf_vardef(cdfid, dname2, [xdimid, ydimid], /short) 
;  ncdf_attput, cdfid, varid2, 'long_name' , lname2         
;  ncdf_attput, cdfid, varid2, 'units' ,  'None'
;  ncdf_attput, cdfid, varid2, 'valid_range' , [1, 255]    ;[1, 255]
;  ncdf_attput, cdfid, varid2, '_FillValue' ,   0 ;
;  ncdf_attput, cdfid, varid2, 'grid_mapping', 'Projection' ;
;  ncdf_attput, cdfid, varid2, 'coordinates' , 'y x' ; 'lines elements'
;  ;ncdf_attput, cdfid, varid5, 'missing_value' ,0 ;
;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;	;;12bit brit values
;   BV12=newdata0
;   IF ( ii EQ 7) THEN BV12=ABS(BV12(*,*)-16383)
;   IF ( ii GT 7) THEN BV12=ABS(BV12(*,*)-4095)
;  dname3='Brit_val_12bit_b' +bb  &  lname3='Brightness values 12bit band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
;  
;  IF( ii eq 7) THEN BEGIN
;    dname3='Brit_val_14bit_b' +bb  &  lname3='Brightness values 14bit band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
;  ENDIF
;    varid3= ncdf_vardef(cdfid, dname3, [xdimid, ydimid], /short) 
;    ncdf_attput, cdfid, varid3, 'long_name' , lname3       
;    ncdf_attput, cdfid, varid3, 'units' ,  'None'
;    ncdf_attput, cdfid, varid3, 'valid_range' , [1, 13684]    ;[1, 255]
;    ncdf_attput, cdfid, varid3, '_FillValue' ,   0 ;
;    ncdf_attput, cdfid, varid3, 'grid_mapping', 'Projection' ;
;    ncdf_attput, cdfid, varid3, 'coordinates' , 'y x' ; 'lines elements'
;   ;ncdf_attput, cdfid, varid12, 'missing_value' ,0 ;
;  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
   
  varid5= ncdf_vardef(cdfid, dname5, [xdimid], /double) 
  ncdf_attput, cdfid, varid5, 'standard_name' , lname5          
  ncdf_attput, cdfid, varid5, 'long_name' , 'west-east angle displacement from sub-point to pixel center'
  ncdf_attput, cdfid, varid5, 'units' , 'radian'
  
  varid7= ncdf_vardef(cdfid, dname7, [ydimid], /double) 
  ncdf_attput, cdfid, varid7, 'standard_name' , lname7   
  ncdf_attput, cdfid, varid7, 'long_name' , 'south-north angle displacement from sub-point to pixel center'
  ncdf_attput, cdfid, varid7, 'units' , 'radian'
  
  ; varid6= ncdf_vardef(cdfid, dname6, [xdimid], /short) 
 ; ncdf_attput, cdfid, varid6, 'long_name' , lname6  
                 
  
 ; varid8= ncdf_vardef(cdfid, dname8, [ydimid], /short) 
 ; ncdf_attput, cdfid, varid8, 'long_name' , lname8  

  varid9= ncdf_vardef(cdfid, dname9, [tdimid], /float) 
  ncdf_attput, cdfid, varid9, 'long_name' , lname9  
  ncdf_attput, cdfid, varid9, 'units' , units9 
  ;;;;;;;;;;;;;;
	
 
    IF (ii LT 7) THEN BEGIN
  ;E_sun_units=' W/(m^2 micrometer)'
  ;E_SUN=STRING(STRTRIM(sdata.E_SUN(ii-1),1)+' '+ STRTRIM(E_sun_units, 1))
  ref_rad=STRING('(Radiance * PI ) / E_sun')
ENDIF
    
    ;;Swath data and time
  dname10='swathtimes'  &  lname10='Nominal swath times' 
  varid10= ncdf_vardef(cdfid, dname10, [sdimid], /short) 
  ncdf_attput, cdfid, varid10, 'long_name' , lname10 
  ncdf_attput, cdfid, varid10, 'units' , 'UTC'           
  ;;;;;;;;;;;;;;
  ;;;;Create the swath data and time
  ;;Image day/times,  mesoscale: 2 scans delta_t=3sec
  swathtime=STRARR(2) ; swath start time for eg '2200utc'
  swathtime(0)=ayear+'-'+amonth+'-'+aday+ '  '+hrs+':'+mins+':00'
  swathtime(1)=ayear+'-'+amonth+'-'+aday+ '  '+hrs+':'+mins+':03'       

 ;mic_rad= '2.8e-05'
 ;IF (ii GT 5 OR ii EQ 3) THEN  mic_rad='5.6e-05'
 ;IF (ii EQ 2 ) THEN  mic_rad='1.4e-05'
 
  varid11= ncdf_vardef(cdfid, 'Projection', /char) 
;ncdf_attput, cdfid, varid11, 'long_name' , 'FGF Projection information' 
ncdf_attput, cdfid, varid11, 'grid_mapping_name' , 'FGFProjection' 
ncdf_attput, cdfid, varid11, '_CoordinateTransformType' , 'Projection'  
ncdf_attput, cdfid, varid11,'_CorrdinateAxes' ,'y x'  
ncdf_attput, cdfid, varid11, 'subpoint_longitude_degrees', '-75.' ;
ncdf_attput, cdfid, varid11,'delta_lambda_radians',mic_rad   ;'2.8e-05'   ; '5.6e-05' ;
ncdf_attput, cdfid, varid11,'units' ,'radian' 
  
 ;;;global variables 
 ;;  ff=size(data.data.gats.name, /n_elements)

		ahistory=  ['The model was simulated on a supercomputer at the National Center for Supercomputing  Applications.', $
			    'The CIMSS forward radiative transfer modeling system was then used to compute  simulated radiances for', $
			    'each ABI band']

  ;;;;;;;;;;;;;;
  ;;;;Create the swath data and time
 
p_time=SYSTIME(0, /UTC)
f_time=STRING(ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins) 

dyk=2 & dxk=2
IF (ii EQ 1 OR ii EQ 2 OR ii EQ 3 OR ii EQ 5) THEN BEGIN
        dyk=1 & dxk=1
ENDIF

;;;;;;;; Adding more information in the global attributes  10/24/2011;;;;;;;;;;

bpp='12' ;;bit per pixel
IF ii EQ 7 THEN bpp='14'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;global variables eastconus
    ncdf_attput, cdfid,  'TITLE', 'PSC-HIRES 500-M ABI VISIBLE DATA REMAPPED TO GOES-R 1-KM FGF DOMAIN',/global 
		ncdf_attput, cdfid,  'INSTITUTE', 'UNIVERSITY OF WISCONSIN-MADISON SSEC/CIMSS', /global
		ncdf_attput, cdfid,  'HISTORY',   'The model was simulated on a supercomputer at the National Center for Supercomputing  Applications. The CIMSS forward radiative transfer modeling system was then used to compute  simulated radiances for each ABI band', /global 
		ncdf_attput, cdfid,  'SOURCE',    'Simulated ABI scaled integer data  for this dataset  were computed using output from a high-resolution Weather Research and Forecasting model coupled with the CIMSS forward radiative transfer models', /global
		ncdf_attput, cdfid,  'REFERENCE', 'Otkin, J. A., T. J. Greenwald, J. Sieglaff, and H.-L. Huang, 2009: Validation of a large-scale simulated brightness temperature dataset using SEVIRI satellite observations. [accepted for publication in/ J. Appl. Meteor. Climatol/.]', /global
		
		ncdf_attput, cdfid,  'Satellite_name', 'GOES-R'  ,/global
    ncdf_attput, cdfid,  'Instrument', 'ABI'  ,/global
    ncdf_attput, cdfid,  'Bits_per_pixel', bpp  ,/global
    ncdf_attput, cdfid,  'Scan_Type', 'Mesoscale'  ,/global
    IF (ii LT 7) THEN BEGIN 
    ncdf_attput, cdfid,  'SOLAR_CONSTANT', '2000 ASTM Standard Extraterrestrial Spectrum Reference E-490-00 for a solar constant of 1366.1 W/m**2' ,/global
    ncdf_attput, cdfid,  'E_sun', E_sun(ii-1), /global
    ncdf_attput, cdfid,  'pi',  '3.14159265', /global
    ncdf_attput, cdfid,  'Reflectance_factor', ref_rad , /global
  ENDIF
    ncdf_attput, cdfid,  'Radiance', '(ABI_scaledint* scale_factor) + add_offset', /global
		ncdf_attput, cdfid,  'Conventions', 'CF-1.4'  ,/global
		ncdf_attput, cdfid,  'FM_AUTHOR',  'CRTM' , /global
		ncdf_attput, cdfid,  'PROCESSED_DATE', p_time, /global
	  ncdf_attput, cdfid,  'FM_CVS_VERSION','Release_Sep08_A', /global
		ncdf_attput, cdfid,  'NWP_MODEL', 'OUTPUT FROM WRF-CHEM MODEL', /global
    ncdf_attput, cdfid,  'CEN_LAT', 0.0000   ,/global    ;37.9999
    ncdf_attput, cdfid,  'CEN_LON',-75.0000 ,/global        ; -97.0000
    ncdf_attput, cdfid,  'OUTPUT_TIME', f_time+'UTC' ,/global
    ncdf_attput, cdfid,  'rotation', 0.     ,/global
     ncdf_attput, cdfid,  'Earth_sun_distance',1. ,/global 
    ncdf_attput, cdfid,  'nominal_satellite_subpoint_lat',0. ,/global 
    ncdf_attput, cdfid,  'nominal_satellite_subpoint_long',-75. ,/global   
   ; ncdf_attput, cdfid,  'Longitude_Subpoint', -75.0 ,/global
   ; ncdf_attput, cdfid,  'WRF_MAP_PROJ', 'Mercator',/global
   ; ncdf_attput, cdfid,  'dyKm',  dyk   ,/global
   ; ncdf_attput, cdfid,  'dxKm',  dyk   ,/global
  
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  

	ncdf_control, cdfid, /endef

;;;
;;;
;;;Creat the lines and elements arrays
;lat_sz=1222 & lon_sz=2654
; IF (ii EQ 1 OR ii EQ 3 OR ii EQ 5) THEN BEGIN
;    lat_sz=2450 & lon_sz=5320
; ENDIF
; larr=INTARR(lat_sz) & earr=INTARR(lon_sz)
;FOR aa=0, lat_sz-1 DO BEGIN
;    larr(aa)=lat_sz-aa
;ENDFOR
;  ;earr=larr   ;&  x=xarr & y=yarr
;  FOR bb=0, lon_sz-1 DO BEGIN
;    earr(bb)=lon_sz-bb
;ENDFOR

;	ncdf_varput, cdfid, varid0, radiance                         ;newdata1
	IF (ii LE 6) THEN ncdf_varput, cdfid, varid1, refl_data
  IF (ii GT 6) THEN ncdf_varput, cdfid, varid1, brit_temp     ;newdata2
;  ncdf_varput, cdfid, varid2, brit_data
;  ncdf_varput, cdfid, varid3, BV12                             ;;12/14bit brit values
  
  
  ;print, 'min X:',min(lons), 'max X:', max(lons)
  ;print, 'min lats:',min(lats), 'max lats:', max(lats)
  ;print, 'min earr:',min(lats), 'max earr:', max(lats)
  ;print, 'min larr:',min(lats), 'max larr:', max(lats)
  
  
  ncdf_varput, cdfid, varid5, lons
  ;ncdf_varput, cdfid, varid6, earr
  ncdf_varput, cdfid, varid7, lats
 ; ncdf_varput, cdfid, varid8, larr
  ncdf_varput, cdfid, varid9, Time
  ncdf_varput, cdfid, varid10, swathtime
  
 ;   ncdf_varput, cdfid, varid0, x; lats
 ; ncdf_varput, cdfid, varid1, y ;lons
;	ncdf_varput, cdfid, varid4, Time
;	 ncdf_varput, cdfid, varid11, swathtime
  
	ncdf_close, cdfid 
;print,'End'

    
;pp=580 & qq=328
;    IF (ii NE 1 OR ii NE 3 OR ii NE 5) THEN BEGIN
;        pp=290  & qq=164
;    ENDIF
;PRINT, 'IN VAL FILE', ii
;PRINT, 'RADIANCE,MIN,    @(290,164)     MAX'
;PRINT, MIN(radiance), radiance(pp,pp), max(radiance)
;  
;  IF (ii GT 6) THEN BEGIN
;    PRINT, 'BRIGHTNESS TEMP ,MIN,    @(290,164)      MAX'
;    PRINT, MIN(brit_temp), brit_temp(pp,qq), max(brit_temp)
;  ENDIF ELSE BEGIN
;     PRINT, 'REFLECTANCE ,MIN,   @(290,164)     MAX'
;    PRINT, MIN(refl_data), refl_data(pp,qq), max(refl_data)
;  ENDELSE
;  
;  
;  PRINT, 'brit08,MIN,    @(290,164)      MAX'
;  PRINT, MIN(brit_data), brit_data(pp,qq), max(brit_data)
;  
;  PRINT, 'brit12,MIN,    @(290,164)      MAX'
;  PRINT, MIN(BV12),   BV12(pp,qq), max(BV12)
;  
;  
;  
;print, min(newdata0), newdata0(pp,qq),  max(newdata0)

;print, 'stop'
;IF (ii GT 6) THEN print, min(newdata2), max(newdata2)
END
;;;;;**********************************************************************************************























;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;; COMPUTE BRIGHTNESS TEMPERATURES FROM THE RADIANCES     
;       tnewdata2=data.dataset(3).data                   ;brightness temp
;       toffset2=data.dataset(3).attrval(2)      &    tscale2=data.dataset(3).attrval(4)
;       tnewdata2=(tnewdata2*tscale2 +toffset2) 
;       
;       ff=size(tnewdata2)
;       newdata2=FLTARR(FF[1],FF[2],1)
;       newdata2(*,*,0)=tnewdata2
;        
       ;       radiance=newdata1                           ;(sdata.data*sdata.scale +sdata.offset)        ;;; getting radiances from GRB-scaled data  
       
       
            ; brit_temp=newdata2          ;(sdata.data2*(1/sdata.s2) + sdata.m2)        ;;; getting brightness temp from GRB-scaled data
       
 ;    brit_data=TBBtoBrit_val(brit_temp)                     ;;; Convert Brightness temperatures to Brit. values.
 ;    lname2= 'Brightness Values 08bit '   + aband+ '('+ bnumber(ii-1) + 'um)' 
 ;    dname2='Brit_val_08bit_b'+bb
 
 
 
 
 ;;;;;;RADIANCE
; varid0= ncdf_vardef(cdfid, dname0, [xdimid, ydimid], /float)  ;;/short
; ncdf_attput, cdfid, varid0, 'long_name' , lname0   
; ncdf_attput, cdfid, varid0, 'units' , units0 
; ;ncdf_attput, cdfid, varid0, '_FillValue', -999.0     ;0   ; -0.123173    ;;;-999.0  ;;miss1 
; ncdf_attput, cdfid, varid0, 'grid_mapping', 'Projection' ;
;  ncdf_attput, cdfid, varid0, 'coordinates' , 'y x' ; 'lines elements'
; ; ncdf_attput, cdfid, varid0, 'coordinates' , 'lines elements'
 
 
 
 
 
 
;   refl_data=newdata0
;     
;    ;;compute min, max of reflectance factors from min max of rad using (R.F=RAD*PI)/E_SUN for visible bands 
;      min_refl=FLTARR(6) & max_refl=FLTARR(6)
;      FOR kk=0, 5 DO BEGIN
;        min_refl(kk)=((min_rad(kk)*pi)/E_sun(kk))   ;;(R.F=RAD*PI)/E_SUN 
;        max_refl(kk)=((max_rad(kk)*pi)/E_sun(kk))
;     ENDFOR
;     
;   ;;;;; Compute the slopes and offsets for each visible band
;      slopes=FLTARR(6) & offsets=FLTARR(6)
; 
;      bit_depth=12
;       FOR jj=0, 5 DO BEGIN
;        ;;;;slope=[y2-y1]/[x2-x1]
;          slopes(jj)=((max_refl(jj)-min_refl(jj))/4095)
;          offsets(jj)=min_refl(jj)  ;slopes(jj)*min_refl(jj) 
;       ENDFOR
;       
;       offsets=offsets(ii-1)  
;       scales=slopes(ii-1)
; 
; 
;      IF ii EQ 1 THEN BEGIN
;            print, 'slopes:', slopes
;            print, 'offsets:', offsets
;     ENDIF
  
  
; varid0= ncdf_vardef(cdfid, dname0, [ydimid], /short) 
;  ncdf_attput, cdfid, varid0, 'long_name' , lname0            
;  ncdf_attput, cdfid, varid0, 'units' ,   'NONE'  ;units0 ;;'degrees'
;;  ncdf_attput, cdfid, varid0, 'valid_range' , [-90.0, 90.0]
;;  ncdf_attput, cdfid, varid0, '_FillValue' ,   -999.0 ;
;;  ncdf_attput, cdfid, varid0, 'missing_value' , -999.0 ;
;; 
;  varid1= ncdf_vardef(cdfid, dname1, [xdimid], /short) 
;  ncdf_attput, cdfid, varid1, 'long_name' , lname1          
;  ncdf_attput, cdfid, varid1, 'units' ,  'NONE'  ;units1  ;;'degrees'
;;;  ncdf_attput, cdfid, varid1, 'valid_range' , [-180, 180.0]
;;  ncdf_attput, cdfid, varid1, '_FillValue' ,   -999.0 ;
;; ncdf_attput, cdfid, varid1, 'missing_value' , -999.0 ;
; varid4= ncdf_vardef(cdfid, dname4, [tdimid], /float) 
;  ncdf_attput, cdfid, varid4, 'long_name' , lname4   
;  ncdf_attput, cdfid, varid4, 'units' , units4 
;    
;; ;;Swath data and time
 ; dname10='swathtimes'  &  lname10='Swath start Time 
 ;   varid10= ncdf_vardef(cdfid, dname10, [sdimid], /short) 
 ;   ncdf_attput, cdfid, varid10, 'long_name' , lname10 
 ;   ncdf_attput, cdfid, varid10, 'units' , units9 
