

;;;;;;;;;;;;;;;;;;;;;;;;;;;;SUB ROUTINES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;CONVERT RADIACNES TO BRIGHTNESS TEMPERATURES   ;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;CONVERT BRIGHTNESS TEMPERATURES TO BRIT VALUES     ;;;;;;;;;;

FUNCTION RadtoBrit_temp2, radiance,ii      ;Convert radiance to Brightness temp.
    
     ;;;;;METHOD 2 IN ATBD
     BC1= [0.50777, 2.12504, 0.33291, 0.06984, 0.17462, 0.10861, 0.13445, 0.25361, 0.27049, 0.07574]
     BC2= [0.99929, 0.99541, 0.9992, 0.99983, 0.99951, 0.99966, 0.99955, 0.9991, 0.99894, 0.99968]
     FK1= [2.00774E+05, 5.03614E+04, 3.54940E+04, 3.00925E+04, 1.93733E+04, 1.34382E+04, 1.07364E+04, 8.48310E+03, 6.40146E+03, 5.06603E+03]
     FK2= [3.68909E+03, 2.326570E+03, 2.07047E+03, 1.95961E+03, 1.69207E+03, 1.49784E+03, 1.38986E+03, 1.28490E+03, 1.16980E+03, 1.08203E+03 ]
     
      ss=ii-7
      www=WHERE(radiance LT 0) ;-999.0)
       
      TBB = [FK2(ss)/ALOG((FK1(ss)/radiance(*,*)+1)) - BC1(ss)]/BC2(ss)
      badd=WHERE(~FINITE(TBB))
      IF N_ELEMENTS(badd) GT 1 THEN BEGIN
       TBB(badd)=-999.0
       ;PRINT, 'STOP'
      ENDIF 
      
       IF (ii EQ 7) THEN BEGIN
            TBB(*,*)=ROUND(TBB(*,*)*1000)
       ENDIF ELSE BEGIN
            TBB(*,*)=ROUND(TBB(*,*)*100)
       ENDELSE
 RETURN,TBB
END




;;;;***********************************************************************************************
PRO WRITE_GRB_CMIP_IR_NETCDF,data, outpre,multivar,katr, ii=ii, mic_rad=mic_rad
   	ncoutfile=outpre ;+'.nc'
  	
	  spos=STRPOS(outpre,'abi_',  /REVERSE_SEARCH)
    ayear=STRMID(outpre, spos+4, 4 )    &    amonth=STRMID(outpre, spos+9, 2)
    aday=STRMID(outpre, spos+11, 2 )    &    hrs=STRMID(outpre, spos+14, 2)
    mins=STRMID(outpre, spos+16, 2 )          ;;;&    ayear=STRMID(outpre, spos+4, 4 )
    
	;;;;METHOD 2 IN ATBD
     BC1= [0.50777, 2.12504, 0.33291, 0.06984, 0.17462, 0.10861, 0.13445, 0.25361, 0.27049, 0.07574]
     BC2= [0.99929, 0.99541, 0.9992, 0.99983, 0.99951, 0.99966, 0.99955, 0.9991, 0.99894, 0.99968]
     FK1= [2.00774E+05, 5.03614E+04, 3.54940E+04, 3.00925E+04, 1.93733E+04, 1.34382E+04, 1.07364E+04, 8.48310E+03, 6.40146E+03, 5.06603E+03]
     FK2= [3.68909E+03, 2.326570E+03, 2.07047E+03, 1.95961E+03, 1.69207E+03, 1.49784E+03, 1.38986E+03, 1.28490E+03, 1.16980E+03, 1.08203E+03 ]
     
     
	
	sdata=SUBSET_DATA(data, multivar,ii, katr) ;; subset lat/lon and data to avoid lat lon missing values
		
	ntimes= size(data.data.dataset,/DIMENSIONS) & uu=size(sdata.data, /DIMENSIONS)
	xx=LONG(uu(0)) & yy=LONG(uu(1))         ;;2654,1222 i.e x and y dimensions. 

	newdata0=sdata.data  ;scaled Radiance.
	lats=sdata.latarr 
	lons=sdata.lonarr                
  offset0= sdata.offset  &    scale0=sdata.scale
  
  ff=size(newdata0)
  radiance=DBLARR(FF[1],FF[2])
  radiance(*,*)=(newdata0*scale0 +offset0)  ;& lats=lats0 & lons=lons0    ;& newdata2=sdata.data2
  
  brit_temp=RadtoBrit_temp2(radiance,ii)       ;;; Convert radiance to Brightness Temp;; From Walter's team
	
     ss=ii-7   
      t_bc1=STRING(STRTRIM(BC1(ss),1)) & t_bc2=STRING(STRTRIM(BC2(ss),1))
      t_fk1=STRING(STRTRIM(FK1(ss),1)) & t_fk2=STRING(STRTRIM(FK2(ss),1)) 
     
bnumber=['0.47','0.64', '0.865', '1.378', '1.61', '2.25', '3.90', '6.19', $
         '6.95', '7.34', '8.50', '9.61', '10.35', '11.2', '12.3', '13.3']

	IF (ii LE 6) THEN BEGIN
		bb= STRING('0'+STRTRIM(ii,1))
		dname0='ABI_GRB_count_b'+ bb ;'ABI_scaledint_'+bb 
		lname0='ABI scaled radiance band0' +strtrim(string(ii),1) +  ' (' + bnumber(ii-1) + 'um)' ;sdata.dattrv(0)+ ' ('+ bnumber(ii-1) + 'um)'
		units0= "watts/m2/steradian/um"  ;sdata.dattrv(1)
		cwlength0=sdata.dattrv(2)
		;;vrange='0.0, 1.0'
	ENDIF ELSE BEGIN 
	   bb= STRING('0'+STRTRIM(ii,1))
      IF (ii GT 9) THEN bb= STRING(STRTRIM(ii,1))
          dname0='ABI_Scaled_TBB_b'+bb   ;'ABI_scaledint_'+bb 
          lname0='ABI brightness temperature band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
          units0='Kelvin'   ;sdata.dattrv2(0)
          cwlength0=sdata.dattrv(2)
          
		ENDELSE

;;; help, data, /structure
		;;vrange1='0.0, 400.0'
	;ENDELSE
	IF ((multivar EQ 1) AND (ii GT 6) ) THEN BEGIN
		bb= STRING('0'+STRTRIM(ii,1))
		IF (ii GT 9) THEN bb= STRING(STRTRIM(ii,1))
	        dname1='ABI_Scaled_TBB_b'+bb
          lname1=sdata.dattrv2(0)+ ' ('+ bnumber(ii-1) + 'um)'
          units1=sdata.dattrv2(1)
          cwlength1=sdata.dattrv2(2)
          ;;vrange2='0.0, 400.0'
	ENDIF

Time=float(0.001)
IF (ii LE 6) THEN E_SUN=sdata.E_SUN(ii-1)  & E_sun_units= 'watts/m2/um'

;print, 'TIME', Time
IF (ii LE 6) THEN print, 'E_SUN',E_SUN
    cdfid=ncdf_create(ncoutfile, /clobber)
   
  ;;Dimensions 	         
	ydimid =ncdf_dimdef(cdfid, 'y',  yy) ;'' 
	xdimid =ncdf_dimdef(cdfid, 'x', xx)  ;''
	;ldimid =ncdf_dimdef(cdfid, 'line',  yy) ;'' 
  ;edimid =ncdf_dimdef(cdfid, 'element', xx)  ;''
	tdimid =ncdf_dimdef(cdfid, 'time', 1)
  bdimid =ncdf_dimdef(cdfid, 'e_sun', 1)
  sdimid =ncdf_dimdef(cdfid, 'swath_t', 2) ;number of swaths in meso
  ;sw2dim =ncdf_dimdef(cdfid, 'sw2', 2)  ;Stores data & time

   ;;Variables	
	 dname5='x' & dname6='elements' & dname7='y' & dname8='lines' & dname9='time' & dname12='E_sun'
   lname5='projection_x_coordinate' & lname6='elements_x_dir' & lname7='projection_y_coordinate' & lname8='lines_y_dir' & lname9='Image start time'
	 units5='None' & units6='None' & units7='None' & units8='None' & units9=STRING('seconds since '+ ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins)    ;2005-05-07 0:0:0'  
	 
	 output_time= STRING(ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins)  
	 
	 ;;;convert to sting
  s_scale= STRTRIM(STRING(sdata.scale),1)  &  s_offset= STRTRIM(STRING(sdata.offset),1)
   ;;get string length  
  l_scale= STRLEN(s_scale)      &    l_offset= STRLEN(s_offset)
  ;; find position of '.' in sting'
  p_scale_pos=STRPOS(s_scale, '.', /REVERSE_SEARCH)   &   p_offset_pos=STRPOS(s_offset, '.', /REVERSE_SEARCH)
  ;;define "format" 
  f_scale='(f'+ STRTRIM(STRING(l_scale),1)+'.'+STRTRIM(STRING(l_scale -p_scale_pos -1),1)+')'
  f_offset='(f'+ STRTRIM(STRING(l_offset),1)+'.'+STRTRIM(STRING(l_offset -p_offset_pos -1),1)+')'
  
  
  IF (ii GT 7) THEN BEGIN
    scale00='0.01' &  offset00='0.00'
    varid0= ncdf_vardef(cdfid, dname0, [xdimid, ydimid], /short) 
    ncdf_attput, cdfid, varid0, 'long_name' , lname0   
    ncdf_attput, cdfid, varid0, 'units' , units0  
    ncdf_attput, cdfid, varid0, 'add_offset' , STRING(offset00 ,format=f_offset), /DOUBLE ;     '(f11.8)'
    ncdf_attput, cdfid, varid0, 'scale_factor' , STRING(scale00 ,format=f_scale), /DOUBLE  ;   '(f13.10)'
    ncdf_attput, cdfid, varid0, 'valid_range' , [1,65536]   ;;2^16
    ncdf_attput, cdfid, varid0, 'valid_min' ,  1     ;-0.10 ;'-0.10, 90000'
    ncdf_attput, cdfid, varid0, '_FillValue' , 0  ;-999.0
    ncdf_attput, cdfid, varid0, 'grid_mapping', 'Projection' ;
    ncdf_attput, cdfid, varid0, 'coordinates' , 'y x' ; 'lines elements'
 ENDIF ELSE BEGIN
        scale00='0.001' &  offset00='0.00'
   varid0= ncdf_vardef(cdfid, dname0, [xdimid, ydimid], /long) 
   ncdf_attput, cdfid, varid0, 'long_name' , lname0   
   ncdf_attput, cdfid, varid0, 'units' , units0 
   ncdf_attput, cdfid, varid0, 'valid_min' ,  1     ;-0.10 ;'-0.10, 90000'
   ;ncdf_attput, cdfid, varid0, '_FillValue' , 0 
   ncdf_attput, cdfid, varid0, 'add_offset' , STRING(offset00 ,format=f_offset), /DOUBLE ;     '(f11.8)'
   ncdf_attput, cdfid, varid0, 'scale_factor' , STRING(scale00 ,format=f_scale), /DOUBLE  ;   '(f13.10)'
   ncdf_attput, cdfid, varid0, 'grid_mapping', 'Projection' ;
   ncdf_attput, cdfid, varid0, 'coordinates' , 'y x' ; 'lines elements'
   ENDELSE
  
  
  
 ; varid0= ncdf_vardef(cdfid, dname0, [xdimid, ydimid], /short) 
 ; ncdf_attput, cdfid, varid0, 'long_name' , lname0   
 ; ncdf_attput, cdfid, varid0, 'units' , units0 
 ; ;ncdf_attput, cdfid, varid0, 'central_wavelength' , FLOAT(cwlength3) 
 ; ncdf_attput, cdfid, varid0, 'add_offset' , STRING(sdata.offset ,format=f_offset), /DOUBLE ;     '(f11.8)'
 ;ncdf_attput, cdfid, varid0, 'scale_factor' , STRING(sdata.scale ,format=f_scale), /DOUBLE  ;   '(f13.10)'
 ;;;  ncdf_attput, cdfid, varid0, 'valid_min' ,  1     ;-0.10 ;'-0.10, 90000'
 ;;; ncdf_attput, cdfid, varid0, '_FillValue' , 0     ;-0.123173  ;;; -999.0   ;;;;
 ; ncdf_attput, cdfid, varid0, 'grid_mapping', 'Projection' ;
 ; ncdf_attput, cdfid, varid0, 'coordinates' , 'y x' ; 'lines elements'
 ;; ncdf_attput, cdfid, varid0, 'missing_value', 0   ; -0.123173    ;;;-999.0  ;;miss1 




varid5= ncdf_vardef(cdfid, dname5, [xdimid], /double) 
  ncdf_attput, cdfid, varid5, 'standard_name' , lname5          
  ncdf_attput, cdfid, varid5, 'long_name' , 'west-east angle displacement from sub-point to pixel center'
  ncdf_attput, cdfid, varid5, 'units' , 'radian'
  
  varid7= ncdf_vardef(cdfid, dname7, [ydimid], /double) 
  ncdf_attput, cdfid, varid7, 'standard_name' , lname7   
  ncdf_attput, cdfid, varid7, 'long_name' , 'south-north angle displacement from sub-point to pixel center'
  ncdf_attput, cdfid, varid7, 'units' , 'radian'
  
  
  
;	varid5= ncdf_vardef(cdfid, dname5, [xdimid], /double) 
;	ncdf_attput, cdfid, varid5, 'standard_name' , lname5          
;	
; ; varid6= ncdf_vardef(cdfid, dname6, [xdimid], /short) 
; ; ncdf_attput, cdfid, varid6, 'long_name' , lname6  
;  
;  varid7= ncdf_vardef(cdfid, dname7, [ydimid], /double) 
;  ncdf_attput, cdfid, varid7, 'standard_name' , lname7                  
;  
;;  varid8= ncdf_vardef(cdfid, dname8, [ydimid], /short) 
;;  ncdf_attput, cdfid, varid8, 'long_name' , lname8  

  varid9= ncdf_vardef(cdfid, dname9, [tdimid], /float) 
  ncdf_attput, cdfid, varid9, 'long_name' , lname9  
  ncdf_attput, cdfid, varid9, 'units' , units9 
  
 
 
  
  ;;;;;;;;;;;;added for E-SUN    ;;;;;;;;;;;;;
  IF (ii LE 6) THEN BEGIN
    varid12= ncdf_vardef(cdfid, dname12, [bdimid], /float) 
    ncdf_attput, cdfid, varid12, 'long_name' , 'E_SUN'   
    ncdf_attput, cdfid, varid12, 'units' , E_sun_units
 ENDIF
  
  
 ;;Swath data and time
  dname10='swathtimes'  &  lname10='Nominal swath times' 
  varid10= ncdf_vardef(cdfid, dname10, [sdimid], /short) 
  ncdf_attput, cdfid, varid10, 'long_name' , lname10 
  ncdf_attput, cdfid, varid10, 'units' , 'UTC'           
  ;;;;;;;;;;;;;;
   ;;;;Create the swath data and time
  ;;Image day/times,  mesoscale: 2 scans delta_t=3sec
  swathtime=STRARR(2) ; swath start time for eg '2200utc'
  swathtime(0)=ayear+'-'+amonth+'-'+aday+ '  '+hrs+':'+mins+':00'
  swathtime(1)=ayear+'-'+amonth+'-'+aday+ '  '+hrs+':'+mins+':03'       

;  dname13='Image times'
;  varid13= ncdf_vardef(cdfid, dname13, [sdimid], /float) 
;  ncdf_attput, cdfid, varid13, 'long_name' , 'Norminal swath times'   
;  ncdf_attput, cdfid, varid13, 'units' , 'None'

 ;;;global variables 
    ff=size(data.data.gats.name, /n_elements)

;;;	FOR k=0, ff-1 DO BEGIN
;;;		ncdf_attput, cdfid, data.data.gats(K).name, STRTRIM(data.data.gats(K).value, 0), /global
;;;	ENDFOR
   	
	;;;;*********************************

		ahistory=  ['The model was simulated on a supercomputer at the National Center for Supercomputing  Applications.', $
			          'The CIMSS forward radiative transfer modeling system was then used to compute  simulated radiances for', $
			          'each ABI band']


 ;mic_rad= '2.8e-05'
 ;IF (ii GT 5 OR ii EQ 3) THEN  mic_rad='5.6e-05'
 ;IF (ii EQ 2 ) THEN  mic_rad='1.4e-05'

varid11= ncdf_vardef(cdfid, 'Projection', /char) 
;ncdf_attput, cdfid, varid11, 'long_name' , 'FGF Projection information' 
ncdf_attput, cdfid, varid11, 'grid_mapping_name' , 'FGFProjection' 
ncdf_attput, cdfid, varid11, '_CoordinateTransformType' , 'Projection'  
ncdf_attput, cdfid, varid11,'_CorrdinateAxes' ,'y x'  
ncdf_attput, cdfid, varid11, 'subpoint_longitude_degrees', '-75.' ;
ncdf_attput, cdfid, varid11,'delta_lambda_radians', mic_rad 
ncdf_attput, cdfid, varid11,'units' ,'radian' 

p_time=SYSTIME(0, /UTC)

dyk=2 & dxk=2
IF (ii EQ 1 OR ii EQ 2 OR ii EQ 3 OR ii EQ 5) THEN BEGIN
        dyk=1 & dxk=1
ENDIF


IF (ii LT 7) THEN BEGIN
  ;E_sun_units=' W/(m^2 micrometer)'
  ;E_SUN=STRING(STRTRIM(sdata.E_SUN(ii-1),1)+' '+ STRTRIM(E_sun_units, 1))
  ref_rad=STRING('(Radiance * PI ) / E_sun')
ENDIF


;;;;;;;; Adding more information in the global attributes  10/24/2011;;;;;;;;;;

bpp='12' ;;bit per pixel
IF ii EQ 7 THEN bpp='14'


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;global variables eastconus
    ncdf_attput, cdfid,  'TITLE', "PSC-HIRES 500-M ABI VISIBLE DATA REMAPPED TO GOES-R 1-KM FGF DOMAIN" ,/global 
		ncdf_attput, cdfid,  'INSTITUTE', 'UNIVERSITY OF WISCONSIN-MADISON SSEC/CIMSS', /global
		ncdf_attput, cdfid,  'HISTORY',   'The WRF-CHEM model was simulated on a supercomputer at the National Center for Supercomputing Applications (NCSA), Pittsburg Supercomputing Center (PSC). A beta version of the NOAA/NESDIS Community Radiative Transfer Model (CRTM) was used then used to compute simulated radiances for each ABI band', /global 
		ncdf_attput, cdfid,  'SOURCE',    'Simulated ABI scaled integer data for this dataset were computed using output from a high-resolution Weather Research and Forecasting model with Chemistry (WRF-CHEM, version 3.0.1) simulation coupled with the NOAA/NESDIS CRTM forward radiative transfer model', /global
		ncdf_attput, cdfid,  'REFERENCE', 'Schaack, T., R. B. Pierce, A. Lenzen, G. Grell, S. Peckham, J. Otkin (2009), High Resolution Coupled RAQMS/WRF-Chem Ozone and Aerosol Simulations for GOES-R Research, Extended Abstracts for the 10th WRF Users Workshop, June 23 - 26, 2009, Boulder, CO', /global
	IF (ii LT 7) THEN BEGIN	
		ncdf_attput, cdfid,  'SOLAR_CONSTANT', '2000 ASTM Standard Extraterrestrial Spectrum Reference E-490-00 for a solar constant of 1366.1 W/m**2' ,/global
		;ncdf_attput, cdfid,  'E_sun', E_SUN, /global
		ncdf_attput, cdfid,  'pi',  '3.14159265', /global
		ncdf_attput, cdfid,  'Reflectance_factor', ref_rad , /global
  ENDIF
    ncdf_attput, cdfid,  'Satellite_name', 'GOES-R'  ,/global
    ncdf_attput, cdfid,  'Instrument', 'ABI'  ,/global
   ; ncdf_attput, cdfid,  'Band Center wavenumbers', 'ABI'  ,/global
    ncdf_attput, cdfid,  'Bits_per_pixel', bpp  ,/global
    ncdf_attput, cdfid,  'Scan_Type', 'Mesoscale'  ,/global
    ncdf_attput, cdfid,  'TBB', '[FK2/ALOG((FK1/radiance+1)) - BC1]/BC2', /global
    ncdf_attput, cdfid,   'FK1', t_fk1, /global
    ncdf_attput, cdfid,   'FK2', t_fk2, /global
    ncdf_attput, cdfid,   'BC1', t_bc1, /global
    ncdf_attput, cdfid,   'BC2', t_bc2, /global
    ncdf_attput, cdfid,  'Radiance', '(ABI_scaledint* scale_factor) + add_offset', /global
    ncdf_attput, cdfid,  'Conventions', 'CF-1.4'  ,/global
   ;ncdf_attput, cdfid,  'REMAP_AUTHOR', 'JASON OTKIN', /global
    ncdf_attput, cdfid,  'FM_AUTHOR', 'CRTM', /global
    ncdf_attput, cdfid,  'PROCESSED_DATE', p_time, /global
    ncdf_attput, cdfid,  'Earth_sun_distance',1. ,/global 
    ncdf_attput, cdfid,  'nominal_satellite_subpoint_lat',0. ,/global 
    ncdf_attput, cdfid,  'nominal_satellite_subpoint_long',-75. ,/global
    ncdf_attput, cdfid,  'FM_CVS_VERSION','Release_Sep09_A', /global
    ncdf_attput, cdfid,  'NWP_MODEL', 'OUTPUT FROM WRF V3.0.1.1 MOD', /global
    ncdf_attput, cdfid,  'CEN_LAT', 0.0000  ,/global  ;37.99999
    ;ncdf_attput, cdfid,  'CEN_LON',-75.000  ,/global  ;-97.0000
    ncdf_attput, cdfid,  'Resolution_km',2.0  ,/global
    ncdf_attput, cdfid,  'Resolution_mircradians',5.6e-05  ,/global
    ncdf_attput, cdfid,  'Longitude_Subpoint',-75.000  ,/global 
    ncdf_attput, cdfid,  'rotation', 0.     ,/global
    ncdf_attput, cdfid,  'OUTPUT_TIME', output_time+'UTC' ,/global
    
    
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


		ncdf_control, cdfid, /endef

;;;
;;;Creat the lines and elements arrays
;lat_sz=1222 & lon_sz=2654
; IF (ii EQ 1 OR ii EQ 3 OR ii EQ 5) THEN BEGIN
;    lat_sz=2450 & lon_sz=5320
; ENDIF
; larr=INTARR(lat_sz) & earr=INTARR(lon_sz)
;FOR aa=0, lat_sz-1 DO BEGIN
;    larr(aa)=lat_sz-aa
;ENDFOR
;  ;earr=larr   ;&  x=xarr & y=yarr
;  FOR bb=0, lon_sz-1 DO BEGIN
;    earr(bb)=lon_sz-bb
;ENDFOR



  ncdf_varput, cdfid, varid0, brit_temp  ;newdata0
	ncdf_varput, cdfid, varid5, lons
	;ncdf_varput, cdfid, varid6, earr
  ncdf_varput, cdfid, varid7, lats
  ;ncdf_varput, cdfid, varid8, larr
	ncdf_varput, cdfid, varid9, Time
  ncdf_varput, cdfid, varid10, swathtime
	IF (ii LE 6) THEN ncdf_varput, cdfid, varid12, E_SUN

	;ncdf_varput, cdfid, varid3, newdata1
	;IF (ii GT 6) THEN ncdf_varput, cdfid, varid2, newdata2
  
  
 ; print, 'In WRITE_GRB'
  print, 'scale: ' ,STRING(sdata.scale ,format=f_scale), ' offset: ' , STRING(sdata.offset, format=f_offset)

	ncdf_close, cdfid   
	


print,'End'

END































































;;;;;**********************************************************************************************




  
  ;PRINT, 'IN GRB FILE', ii
  ;PRINT, 'SCALED RADIANCE,MIN,    @580,328     MAX'
  ;pp=1327 & qq=611
   ; IF (ii EQ 1 OR ii EQ 2 OR ii EQ 3 OR ii EQ 5) THEN BEGIN
    ;    pp=2654  & qq=1222
    ;ENDIF
  ;PRINT, MIN(newdata0), newdata0(pp,qq), max(newdata0)

;;;;
;;;;	varid4= ncdf_vardef(cdfid, 'lat', [ydimid, xdimid], /float)
;;;;	ncdf_attput, cdfid, varid4, 'long_name' , 'Latitude'   
;;;;	ncdf_attput, cdfid, varid4, 'units' , 'degrees_north' 
;;;;;;;;	ncdf_attput, cdfid, varid4, 'scale_factor' , 0.00001 ;0.0055084899746 ;  0.01
;;;;	ncdf_attput, cdfid, varid4, 'valid_range' , '90.0, -90.0'
;;;;	ncdf_attput, cdfid, varid4, '_FillValue' , -999.0 ;-32768 ;;;;
;;;;
;;;;	varid3= ncdf_vardef(cdfid, 'lon', [ydimid, xdimid], /float)
;;;;	ncdf_attput, cdfid, varid3, 'long_name' , 'Longitude'   
;;;;	ncdf_attput, cdfid, varid3, 'units' , 'degrees_east' 
;;;;;;;;	ncdf_attput, cdfid, varid3, 'scale_factor' , 0.00001 ;0.0055084899746 ;  0.01
;;;;	ncdf_attput, cdfid, varid3, 'valid_range' , '-180.0, 180.0'
;;;;	ncdf_attput, cdfid, varid3, '_FillValue' , -999.0 ;-32768 ;;;;
;;;; 	




;IF (ii GT 6) THEN BEGIN
;  scale2=1.0/sdata.s2 & offset2=sdata.m2
;  varid2= ncdf_vardef(cdfid, dname2, [ydimid, xdimid,tdimid], /short) 
;  ncdf_attput, cdfid, varid2, 'long_name' , lname2   
;  ncdf_attput, cdfid, varid2, 'units' , units2 
;  ;ncdf_attput, cdfid, varid2, 'central_wavelength' , FLOAT(cwlength3) 
;  ncdf_attput, cdfid, varid2, 'add_offset' , STRING(offset2, format='(f3.2)'), /FLOAT ;
;  ncdf_attput, cdfid, varid2, 'coordinates' , 'lat lon'
;  ncdf_attput, cdfid, varid2, 'scale_factor' , STRING(scale2, format='(f4.2)'), /FLOAT 
;  ncdf_attput, cdfid, varid2, 'valid_min' ,  0    ;sdata.m2     ;-0.10 ;'-0.10, 90000'
;  ncdf_attput, cdfid, varid2, '_FillValue' , sdata.m2     ;-0.123173  ;;; -999.0   ;;;;
;  ncdf_attput, cdfid, varid2, 'missing_value', sdata.m2   ; -0.123173    ;;;-999.0  ;;miss1
;  
;;  print,   STRING(sdata.offset, format='(f10.7)')
;;  print,  STRING(scale2, format='(f10.7)')
;ENDIF
;  
;  print,   STRING(sdata.offset, format='(f10.7)')
;  print,  STRING(sdata.scale , format='(f10.7)')
;  
;  
;  
;  
;   ;bb= STRING('0'+STRTRIM(ii,1))
    ;IF (ii GT 9) THEN bb= STRING(STRTRIM(ii,1))
    ;dname0='ABI_GRB_count_b'+bb 
    ;IF (ii EQ 7) THEN BEGIN
    ; lname0='ABI_scaled radiance band0' +strtrim(string(ii),1)  + ' ('+ bnumber(ii-1) + 'um)'  ;sdata.dattrv(0)+ ' ('+ bnumber(ii-1) + 'um)'
    ; units0= "watts/m2/steradian/um"  ;sdata.attrv1(1)
    ; cwlength0=sdata.dattrv(2)
    ;ENDIF ELSE BEGIN
    ; lname0= 'ABI_scaled radiance band' + strtrim(string(ii),1)   + ' ('+ bnumber(ii-1) + 'um)'           ;sdata.dattrv(0)+ ' ('+ bnumber(ii-1) + 'um)'
    ; units0="watts/m2/steradian/um"   ;;;sdata.dattrv(2)
    ; cwlength0=sdata.dattrv(2)
    
;  
