
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FUNCTION TBBtoBrit_val, brit_temp     ;CONVERT A BRIGHTNESS TEMPERATURE TO BRIT. VALUE
  brit_val=brit_temp
  brit_val(*,*)=0.0 
 con1=418   &  con2=660   &  tlim=242.0  & range=[163, 330]
 lower_temps= WHERE(brit_temp LT tlim AND brit_temp NE -999.0)    & upper_temps= WHERE(brit_temp GE tlim)
 too_low=WHERE(brit_temp LT range[0])  & too_high= WHERE(brit_temp GT range[1])
 
 IF (N_ELEMENTS(lower_temps) GT 1) THEN  brit_val(lower_temps) = (con1 -ROUND(brit_temp(lower_temps)))
 IF (N_ELEMENTS(upper_temps) GT 1) THEN  brit_val(upper_temps) = (con2 -ROUND(2 * brit_temp(upper_temps)))
  
 IF (N_ELEMENTS(too_low) GT 1) THEN  brit_val(too_low)=-999.0    ;0  ;255  
 IF (N_ELEMENTS(too_high) GT 1) THEN  brit_val(too_high)=-999.0  ;0
  badd=WHERE(brit_temp LT 0)
  IF (SIZE(badd, /DIMENSION) GT 0) THEN brit_val(badd)=-999.0    ;0.0
   
 RETURN, brit_val
END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;SUB ROUTINES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;CONVERT RADIACNES TO BRIGHTNESS TEMPERATURES   ;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;CONVERT BRIGHTNESS TEMPERATURES TO BRIT VALUES     ;;;;;;;;;;

FUNCTION RadtoBrit_temp, radiance,ii       ;Convert radiance to Brightness temp.
     ;;;;;METHOD 2 IN ATBD
     BC1= [0.50777, 2.12504, 0.33291, 0.06984, 0.17462, 0.10861, 0.13445, 0.25361, 0.27049, 0.07574]
     BC2= [0.99929, 0.99541, 0.9992, 0.99983, 0.99951, 0.99966, 0.99955, 0.9991, 0.99894, 0.99968]
     FK1= [2.00774E+05, 5.03614E+04, 3.54940E+04, 3.00925E+04, 1.93733E+04, 1.34382E+04, 1.07364E+04, 8.48310E+03, 6.40146E+03, 5.06603E+03]
     FK2= [3.68909E+03, 2.326570E+03, 2.07047E+03, 1.95961E+03, 1.69207E+03, 1.49784E+03, 1.38986E+03, 1.28490E+03, 1.16980E+03, 1.08203E+03 ]
     
      ss=ii-7
      www=WHERE(radiance LT 0) ;-999.0)
       
      TBB = [FK2(ss)/ALOG((FK1(ss)/radiance(*,*)+1)) - BC1(ss)]/BC2(ss)
      badd=WHERE(~FINITE(TBB))
      IF N_ELEMENTS(badd) GT 1 THEN BEGIN
       TBB(badd)=-999.0
       PRINT, '  '
      ENDIF 
      
 RETURN,TBB
END


;;;;***********************************************************************************************
PRO WRITE_VAL_FROM_GRB_SCALED_NETCDF,infile, outpre,multivar,katr, latlonfile, data2, ii=ii, mic_rad=mic_rad
  infile=infile  ;+ '.nc'
  xx='x' & yy='y' & var=1 & vars=0 & rep=1 & vars=['ABI_Scaled_']
  
  
     data=READ_CALNEX_NETCDF_01(infile, xx=xx, yy=yy, rep=rep, vars=vars)
    
    ; lldata=data2.latlon
   	
   	 ncoutfile=outpre ;+'.nc'
	  
	  spos=STRPOS(outpre,'.04_',  /REVERSE_SEARCH)
    ayear=STRMID(outpre, spos+4, 4 )   &    amonth=STRMID(outpre, spos+9, 2)
    aday=STRMID(outpre, spos+11, 2 )    &    hrs=STRMID(outpre, spos+14, 2)
    mins=STRMID(outpre, spos+16, 2 )          ;;;&    ayear=STRMID(outpre, spos+4, 4 )
  
	
	;sdata=SUBSET_DATA(data, multivar,ii, katr) ;; subset lat/lon and data to avoid lat lon missing values
		
	;ntimes= size(data.data.dataset,/DIMENSIONS) 
	uu=size(data.dataset.data,/DIMENSIONS)    ;size(sdata.data, /DIMENSIONS)
	 xsize=LONG(uu(0)) & ysize=LONG(uu(1))     ;;xx=LONG(uu(0)) & yy=LONG(uu(1))         ;;2654,1222 i.e x and y dimensions. 


 min_range=[-25.93664701,-20.28991094,-12.03764377,-4.52236858,-3.05961376,-0.96095066,-0.0114,-0.1692,-0.2472,-0.2871,-0.3909,-0.4617,-0.4935,-0.5154,-0.5262,-1.5726]
 max_range=[804.03605737,628.98723908,373.16695681,140.19342584,94.84802665,29.78947040,24.962,28.366,44.998,79.831,134.93,108.44,183.62,198.71,212.28,170.19]

	
	 xx=data.x
   yy=data.y
   elements=data.elements
   lines=data.lines 
   gatts=data.gats
	 newdata0=data.dataset(0).data                   ;scaled Radiance.
   offset0=data.dataset(0).attrval(2)  &    scale0=data.dataset(0).attrval(3)
	
	ff=size(newdata0)
	radiance=DBLARR(FF[1],FF[2])
	;lats=newdata1 & lons=newdata1
	radiance(*,*)=(newdata0*scale0 +offset0)  ;& lats=lats0 & lons=lons0    ;& newdata2=sdata.data2
	kk=where(radiance lt 0)
  uu=WHERE(radiance LT min_range(ii-1)) & vv=WHERE(radiance GT max_range(ii-1))
	IF SIZE(kk, /N_ELEMENTS) GE 1 THEN radiance(kk)=-999.0  
	IF SIZE(uu, /N_ELEMENTS) GE 1 THEN radiance(uu)=-999.0
	IF SIZE(VV, /N_ELEMENTS) GE 1 THEN radiance(vv)=-999.0


bnumber=['0.47','0.64', '0.865', '1.378', '1.61', '2.25', '3.90', '6.19', $
         '6.95', '7.34', '8.50', '9.61', '10.35', '11.2', '12.3', '13.3']
         

 E_sun=[1993.660, 1605.9593, 969.7815, 357.3011, 244.7938, 75.3057]

	
		bb= STRING('0'+STRTRIM(ii,1))              ;;radiances
		IF (ii GT 9) THEN bb= STRING(STRTRIM(ii,1))
		  dname0='ABI_Rad_b'+bb  ;;'ABI_scaledint_'+bb 
			lname0='ABI radiance band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
			units0="watts/m2/steradian/um"   ;;;sdata.dattrv(2)
			IF (ii GT 6) THEN units0="milliwatts/m2/steradian/cm-1"   
			;cwlength2=sdata.dattrv(3)

   IF (ii LE 6) THEN BEGIN
      bb= STRING('0'+STRTRIM(ii,1))
      dname1='ABI_Refl_fact_b'+bb     ;'ABI_scaledint_'+bb 
      lname1='ABI reflectance factor band'+ bb+ '('+ bnumber(ii-1) + 'um)'   ;sdata.dattrv(1)+ 
      units1='none'    ;'milliwatts/m2/steradian/cm-1'     ;sdata.dattr2v(0)
      ;cwlength1=sdata.dattrv(3)
      ;;vrange='0.0, 1.0'
   ENDIF 
	 IF ( (ii GT 6) ) THEN BEGIN  ;(multivar EQ 1) AND
		  bb= STRING('0'+STRTRIM(ii,1))
		  IF (ii GT 9) THEN bb= STRING(STRTRIM(ii,1))
	        dname1='ABI_TBB_b'+bb   ;'ABI_scaledint_'+bb 
          lname1='ABI brightness temperature band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
          units1='Kelvin'   ;sdata.dattrv2(0)
         ; cwlength1=sdata.dattrv2(3)
          ;;vrange1='0.0, 400.0'
	ENDIF


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;added to output Brit values for the validation files.
  ww='band0'
  IF (ii GT 9) THEN ww='band '
  aband=STRING(ww)+ (STRTRIM(ii,1))

IF (ii LT 7) THEN BEGIN
  ;;Converts a reflectance factor value to a brightness value. ;;! --- via a square-root function
 ;;ww=1
  rrange=[0,2.5] &  too_low=WHERE( radiance LT rrange[0])  & too_high=WHERE(radiance GT rrange[1]) & refl_range=[0,1]
  
  ;; Convert  scaled_int (reflectance) back to float to get the output from Grb files instead of the original values. 
  ;newdata1=sdata.data*sdata.scale + sdata.offset
  
   ;;;GET SCALED RADIANCES
   ;radiance=newdata1
  
   ;;;CONVER RADIANCE TO REFLECTANCE 
     refl_data=(!PI*radiance)/E_sun(ii-1)
     refl_data(kk)=-999.0
  ;; CONVERT REFLECTANCE TO BRIT VALUES
     brit_data=refl_data   
  IF (N_ELEMENTS(too_low) GT 1)  THEN brit_data(too_low)=0  
 ; IF (N_ELEMENTS(too_high) GT 1) THEN brit_data(too_high)=0  ;255
       brit_data =ROUND(SQRT(brit_data*100)*25.5)   ;;;;;;ROUND(SQRT(data.dataset(ww).data*100)*25.5)
        brit_data(too_low)=-999 ;0
        pp=WHERE(brit_data GT 255)
        qq=WHERE(brit_data LT 0)
   IF SIZE(pp, /N_ELEMENTS) GE 1 THEN brit_data(pp)=255  
   IF SIZE(qq, /N_ELEMENTS) GE 1 THEN brit_data(qq)=-999 ;0
  
        
     
    lname2= 'Brightness Values '   + aband+ ' ('+ bnumber(ii-1) + 'um)'
    dname2='Brit_val_08bit_b'+bb
    ;print, min(brit_data), max(brit_data)
   
ENDIF ELSE BEGIN
     
       ;       radiance=newdata1                           ;(sdata.data*sdata.scale +sdata.offset)        ;;; getting radiances from GRB-scaled data  
        brit_temp=RadtoBrit_temp(radiance,ii)                 ;;; Convert radiance to Brightness Temp;; From Walter's team
   
        newdata2=brit_temp
     
       ; brit_temp=newdata2          ;(sdata.data2*(1/sdata.s2) + sdata.m2)        ;;; getting brightness temp from GRB-scaled data
       
     brit_data=TBBtoBrit_val(brit_temp)                     ;;; Convert Brightness temperatures to Brit. values.
     lname2= 'Brightness Values 08bit '   + aband+ '('+ bnumber(ii-1) + 'um)' 
     dname2='Brit_val_08bit_b'+bb
ENDELSE 
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


Time=float(0.001)

  cdfid=ncdf_create(ncoutfile, /clobber)
  sdimid =ncdf_dimdef(cdfid, 'sw1', 22) ;number of swaths in FD
  
     
   
  ;;Dimensions           
  ydimid =ncdf_dimdef(cdfid, 'y', ysize) ;'' 
  xdimid =ncdf_dimdef(cdfid, 'x', xsize)  ;''
  tdimid =ncdf_dimdef(cdfid, 'time', 1)
  bdimid =ncdf_dimdef(cdfid, 'e_sun', 1)
  sdimid =ncdf_dimdef(cdfid, 'swath_t', 22) ;number of swaths in FD
  
	   
	   ;;Variables 
	 ;  dname3='Brit_val_12bit_b' +bb  &  lname3='Brightness values 12bit band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
   dname5='x' & dname6='elements' & dname7='y' & dname8='lines' & dname9='time' & dname12='E_sun'   ;& dname2='brit_val'
   lname5='projection_x_coordinate' & lname6='elements_x_dir' & lname7='projection_y_coordinate' & lname8='lines_y_dir' & lname9='Image start time'
   units5='None' & units6='None' & units7='None' & units8='None' & units9=STRING('seconds since '+ ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins)    ;2005-05-07 0:0:0'  
   
   output_time= STRING(ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins)  
	
 ;;;;;RADIANCE
  varid0= ncdf_vardef(cdfid, dname0, [xdimid, ydimid], /float)  ;;/short
	ncdf_attput, cdfid, varid0, 'long_name' , lname0   
	ncdf_attput, cdfid, varid0, 'units' , units0 
	ncdf_attput, cdfid, varid0, '_FillValue', -999.0     ;0   ; -0.123173    ;;;-999.0  ;;miss1 
	ncdf_attput, cdfid, varid0, 'grid_mapping', 'Projection' ;
  ncdf_attput, cdfid, varid0, 'coordinates' , 'y x' ; 'lines elements'
 ; ncdf_attput, cdfid, varid0, 'coordinates' , 'lines elements'
 
  
 ; IF (ii GT 6) THEN BEGIN
 ;;;REFLECTANCE OR TBB
  varid1= ncdf_vardef(cdfid, dname1, [xdimid, ydimid], /float) 
  ncdf_attput, cdfid, varid1, 'long_name' , lname1   
  ncdf_attput, cdfid, varid1, 'units' , units1 
  ncdf_attput, cdfid, varid1, '_FillValue', -999.0       ;sdata.m2   ; -0.123173    ;;;-999.0  ;;miss1
  ncdf_attput, cdfid, varid1, 'grid_mapping', 'Projection' ;
  ncdf_attput, cdfid, varid1, 'coordinates' , 'y x' ; 'lines elements'

        
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;;;Added to outupt Brit values.
	varid2= ncdf_vardef(cdfid, dname2, [xdimid, ydimid], /short) 
  ncdf_attput, cdfid, varid2, 'long_name' , lname2         
  ncdf_attput, cdfid, varid2, 'units' ,  'None'
  ncdf_attput, cdfid, varid2, 'valid_range' , [0, 255]    ;[1, 255]
  ncdf_attput, cdfid, varid2, '_FillValue' ,   -999 ;
  ncdf_attput, cdfid, varid2, 'grid_mapping', 'Projection' ;
  ncdf_attput, cdfid, varid2, 'coordinates' , 'y x' ; 'lines elements'
  ;ncdf_attput, cdfid, varid5, 'missing_value' ,0 ;
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	;;12bit brit values
   BV12=newdata0
  ; cc=WHERE(BV12 LT 0)
  ; BV12(cc)=0
   IF ( ii EQ 7) THEN BV12=ABS(BV12(*,*)-16383)
   IF ( ii GT 7) THEN BV12=ABS(BV12(*,*)-4095)
   
  ;;;Put -999 for missing values
    zz=WHERE(newdata0 LE 0)
    IF (N_ELEMENTS(zz) GT 1)  THEN BV12(zz)=-999.0
   
 ;  IF ( ii EQ 7) THEN BV12=(BV12(*,*)-16383)
 ;  IF ( ii GT 7) THEN BV12=(BV12(*,*)-4095)
   
  dname3='Brit_val_12bit_b' +bb  &  lname3='Brightness values 12bit band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
  
  IF( ii eq 7) THEN BEGIN
    dname3='Brit_val_14bit_b' +bb  &  lname3='Brightness values 14bit band'+bb+ ' ('+ bnumber(ii-1) + 'um)'
  ENDIF
    varid3= ncdf_vardef(cdfid, dname3, [xdimid, ydimid], /short) 
    ncdf_attput, cdfid, varid3, 'long_name' , lname3       
    ncdf_attput, cdfid, varid3, 'units' ,  'None'
    ncdf_attput, cdfid, varid3, 'valid_range' , [0, 13684]    ;[1, 255]
    ncdf_attput, cdfid, varid3, '_FillValue' ,   -999 ;
    ncdf_attput, cdfid, varid3, 'grid_mapping', 'Projection' ;
    ncdf_attput, cdfid, varid3, 'coordinates' , 'y x' ; 'lines elements'
   ;ncdf_attput, cdfid, varid12, 'missing_value' ,0 ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
  
  varid5= ncdf_vardef(cdfid, dname5, [xdimid], /double) 
  ncdf_attput, cdfid, varid5, 'standard_name' , lname5          
  ncdf_attput, cdfid, varid5, 'long_name' , 'west-east angle displacement from sub-point to pixel center'
  ncdf_attput, cdfid, varid5, 'units' , 'radians'
  
  varid7= ncdf_vardef(cdfid, dname7, [ydimid], /double) 
  ncdf_attput, cdfid, varid7, 'standard_name' , lname7   
  ncdf_attput, cdfid, varid7, 'long_name' , 'south-north angle displacement from sub-point to pixel center'
  ncdf_attput, cdfid, varid7, 'units' , 'radians'
  
     
;  
 varid6= ncdf_vardef(cdfid, dname6, [xdimid], /short) 
 ncdf_attput, cdfid, varid6, 'long_name' , lname6  
;             
;  
 varid8= ncdf_vardef(cdfid, dname8, [ydimid], /short) 
 ncdf_attput, cdfid, varid8, 'long_name' , lname8  

  varid9= ncdf_vardef(cdfid, dname9, [tdimid], /float) 
  ncdf_attput, cdfid, varid9, 'long_name' , lname9  
  ncdf_attput, cdfid, varid9, 'units' , units9 
  ;;;;;;;;;;;;;;
	
    
    
    ;;Swath data and time
  dname10='swathtimes'  &  lname10='Nominal swath times' 
  varid10= ncdf_vardef(cdfid, dname10, [sdimid], /short) 
  ncdf_attput, cdfid, varid10, 'long_name' , lname10 
  ncdf_attput, cdfid, varid10, 'units' , 'None'   
  
  
  
  ;QUALITY FLAG ARRAY INFORMATIONS
  dname20='qualityflag'  &  lname20='Quality flag: 0=good, 1=cond. unstable, 2=saturated, 3=missing' 
  varid20= ncdf_vardef(cdfid, dname20, [xdimid, ydimid], /short) 
  ncdf_attput, cdfid, varid20, 'long_name' , lname20 
  ncdf_attput, cdfid, varid20, 'units' , 'None'           
  
          
  ;;;;;;;;;;;;;;
  ;;;;Create the swath data and time
  ;;Image day/times,  mesoscale: 2 scans delta_t=3sec
  swathtime=STRARR(2) ; swath start time for eg '2200utc'
  swathtime(0)=hrs+':'+mins+':00'
  swathtime(1)=hrs+':'+mins+':03'       

; mic_rad= '2.8e-05'
 
  varid11= ncdf_vardef(cdfid, 'Projection', /char) 
;ncdf_attput, cdfid, varid11, 'long_name' , 'FGF Projection information' 
ncdf_attput, cdfid, varid11, 'grid_mapping_name' , 'FGFProjection' 
ncdf_attput, cdfid, varid11, '_CoordinateTransformType' , 'Projection'  
ncdf_attput, cdfid, varid11,'_CorrdinateAxes' ,'y x'  
ncdf_attput, cdfid, varid11, 'subpoint_longitude_degrees', '-75.' ;
ncdf_attput, cdfid, varid11,'delta_lambda_radians',mic_rad   ;'2.8e-05'   ; '5.6e-05' ;
ncdf_attput, cdfid, varid11,'units' ,'radian' 



  
 ;;;global variables 
 ;;  ff=size(data.data.gats.name, /n_elements)

		ahistory=  ['The model was simulated on a supercomputer at the National Center for Supercomputing  Applications.', $
			    'The CIMSS forward radiative transfer modeling system was then used to compute  simulated radiances for', $
			    'each ABI band']

  ;;;;;;;;;;;;;;
  ;;;;Create the swath data and time
 
p_time=SYSTIME(0, /UTC)
f_time=STRING(ayear+'-'+ amonth+'-'+aday+' '+hrs+':'+mins) 

dyk=2 & dxk=2
IF (ii EQ 1 OR ii EQ 2 OR ii EQ 3 OR ii EQ 5) THEN BEGIN
        dyk=1 & dxk=1
ENDIF

;;;;;;;; Adding more information in the global attributes  10/24/2011;;;;;;;;;;

bpp='12' ;;bit per pixel
IF ii EQ 7 THEN bpp='14'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;global variables eastconus

  ncdf_attput, cdfid,  'TITLE', 'PUG CONUS DOMAIN REMAPPED TO GOES-R 2-KM FGF DOMAIN' ,/global 
    ncdf_attput, cdfid,  'INSTITUTE', 'NOAA/NESDIS/CIMSS', /global
    ncdf_attput, cdfid,  'HISTORY',   'REAL TIME 8-KM ABI DATA REMAPPED TO GOES-R 2-KM DOMAIN', /global 
    ncdf_attput, cdfid,  'SOURCE',    'Projection FGF75W_CONUS_2km_FDref.lat.lon.flipped.NS.with.projection.nc', /global
    ncdf_attput, cdfid,  'SOURCE',    'Simulated ABI scaled integer data for this dataset were computed using output from a high-resolution Weather Research and Forecasting model with Chemistry (WRF-CHEM, version 3.0.1) simulation coupled with the NOAA/NESDIS CRTM forward radiative transfer model', /global
    ncdf_attput, cdfid,  'REFERENCE', 'Schaack, T., R. B. Pierce, A. Lenzen, G. Grell, S. Peckham, J. Otkin (2009), High Resolution Coupled RAQMS/WRF-Chem Ozone and Aerosol Simulations for GOES-R Research, Extended Abstracts for the 10th WRF Users Workshop, June 23 - 26, 2009, Boulder, CO', /global
  IF (ii LE 6) THEN BEGIN 
    ncdf_attput, cdfid,  'SOLAR_CONSTANT', '2000 ASTM Standard Extraterrestrial Spectrum Reference E-490-00 for a solar constant of 1366.1 W/m**2' ,/global
    ;ncdf_attput, cdfid,  'E_sun', E_SUN, /global
   ; ncdf_attput, cdfid,  'pi',  '3.14159265', /global
   ; ncdf_attput, cdfid,  'Reflectance_factor', ref_rad , /global
  ENDIF
    ncdf_attput, cdfid,  'Satellite_name', 'GOES-R'  ,/global
    ncdf_attput, cdfid,  'Instrument', 'ABI'  ,/global
   ; ncdf_attput, cdfid,  'Band Center wavenumbers', 'ABI'  ,/global
    ncdf_attput, cdfid,  'Bits_per_pixel', bpp  ,/global
    ncdf_attput, cdfid,  'Scan_Type', 'Mesoscale'  ,/global
    
    ncdf_attput, cdfid,  'Radiance', '(ABI_scaledint* scale_factor) + add_offset', /global
    ncdf_attput, cdfid,  'Conventions', 'CF-1.4'  ,/global
  ; ncdf_attput, cdfid,  'REMAP_AUTHOR', 'JASON OTKIN', /global
    ncdf_attput, cdfid,  'FM_AUTHOR', 'CRTM', /global
    ncdf_attput, cdfid,  'PROCESSED_DATE', p_time, /global
    ncdf_attput, cdfid,  'Earth_sun_distance',1. ,/global
    ncdf_attput, cdfid,  'nominal_satellite_subpoint_lat',0. ,/global 
    ncdf_attput, cdfid,  'nominal_satellite_subpoint_long',-75. ,/global
    ncdf_attput, cdfid,  'FM_CVS_VERSION','Release_Sep09_A', /global
    ncdf_attput, cdfid,  'NWP_MODEL', 'OUTPUT FROM WRF-CHEM MODEL', /global
    ncdf_attput, cdfid,  'CEN_LAT', 0.0000  ,/global  ;37.99999
    ;ncdf_attput, cdfid,  'CEN_LON',-75.000  ,/global  ;-97.0000
    ncdf_attput, cdfid,  'Resolution_km',2.0  ,/global
    ncdf_attput, cdfid,  'Resolution_mircradians',5.6e-05  ,/global
    ncdf_attput, cdfid,  'Longitude_Subpoint',-75.000  ,/global 
    ncdf_attput, cdfid,  'rotation', 0.     ,/global
    ncdf_attput, cdfid,  'OUTPUT_TIME', output_time+'UTC' ,/global
    
    
    
    
  

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  

	ncdf_control, cdfid, /endef



	ncdf_varput, cdfid, varid0, radiance                         ;newdata1
	IF (ii LE 6) THEN ncdf_varput, cdfid, varid1, refl_data
  IF (ii GT 6) THEN ncdf_varput, cdfid, varid1, brit_temp     ;newdata2
  ncdf_varput, cdfid, varid2, brit_data
  ncdf_varput, cdfid, varid3, BV12                             ;;12/14bit brit values
  
  
  
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; compute the QF array: 0=good, 3=missing.
IF (ii LE 6) THEN BEGIN
      ss=SIZE(refl_data, /DIMENSIONS)
      badd=WHERE(refl_data LT 0, COMPLEMENT=goodd)
ENDIF
IF (ii GT 6) THEN BEGIN
    ss=SIZE(brit_temp, /DIMENSIONS)
   badd=WHERE(brit_temp LT 0, COMPLEMENT=goodd)
ENDIF

QF_ARR=FLTARR(ss[0],ss[1])
QF_ARR(goodd)=0  
QF_ARR(badd)=3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
  
  
  ;print, 'min X:',min(lons), 'max X:', max(lons)
  ;print, 'min lats:',min(lats), 'max lats:', max(lats)
  ;print, 'min earr:',min(lats), 'max earr:', max(lats)
  ;print, 'min larr:',min(lats), 'max larr:', max(lats)
  
  ncdf_varput, cdfid, varid20, QF_ARR
  ncdf_varput, cdfid, varid5, xx.data           ;lons
  ncdf_varput, cdfid, varid6, elements.data     ;earr
  ncdf_varput, cdfid, varid7, yy.data           ;lats
  ncdf_varput, cdfid, varid8, lines.data        ;larr
  ncdf_varput, cdfid, varid9, Time
  ncdf_varput, cdfid, varid10, swathtime
  
  
	ncdf_close, cdfid 
END
;;;;;**********************************************************************************************

